SystemOrganization addCategory: #ConfigurationOfFamiliar!

Object subclass: #ConfigurationOfFamiliar
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfFamiliar'!

!ConfigurationOfFamiliar class methodsFor: 'development support' stamp: 'AlexandreBergel 7/1/2012 16:10'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfFamiliar class methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 16:10'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfFamiliar class methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 16:10'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfFamiliar class methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 16:10'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfFamiliar class methodsFor: 'metacello tool support' stamp: 'AlexandreBergel 7/1/2012 16:10'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfFamiliar class methodsFor: 'loading' stamp: 'AlexandreBergel 7/1/2012 16:10'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfFamiliar class methodsFor: 'loading' stamp: 'AlexandreBergel 7/1/2012 16:10'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfFamiliar class methodsFor: 'loading' stamp: 'AlexandreBergel 7/1/2012 16:10'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfFamiliar class methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 16:10'!
project

	^self new project! !

!ConfigurationOfFamiliar class methodsFor: 'development support' stamp: 'AlexandreBergel 7/1/2012 16:10'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfFamiliar methodsFor: 'baselines' stamp: 'AlexandreBergel 7/1/2012 16:10'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/Familiar'.
		spec package: 'Familiar'.
		spec group: 'default' with: #('Familiar' ). ].
! !

!ConfigurationOfFamiliar methodsFor: 'symbolic versions' stamp: 'AlexandreBergel 7/4/2012 17:40'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.17'.
! !

!ConfigurationOfFamiliar methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 16:10'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/3/2012 13:53'!
version010: spec
	<version: '0.10' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.9 : added kind for each feature (e.g., isOptional, isOr)
0.10 : Added better popupText in the Complexity view'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/3/2012 13:53'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.10'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/3/2012 15:32'!
version011: spec
	<version: '0.11' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.10 : Added better popupText in the Complexity view
0.11 : Packaged the thing. Take the constraints into accounts'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/3/2012 15:32'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.11'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/3/2012 16:16'!
version012: spec
	<version: '0.12' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.11 : Packaged the thing. Take the constraints into accounts
0.12 : A bit of refactoring in the visualizations. Decoupled and works better'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/3/2012 16:16'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.12'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/3/2012 17:05'!
version013: spec
	<version: '0.13' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.12 : A bit of refactoring in the visualizations. Decoupled and works better
0.13 : Worked on the Moose Importer. Can select a file now'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/3/2012 17:05'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.13'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/3/2012 18:56'!
version014: spec
	<version: '0.14' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.13 : Worked on the Moose Importer. Can select a file now
0.14 : Worked on the highlighting'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/3/2012 18:56'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.14'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/4/2012 12:45'!
version015: spec
	<version: '0.15' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.14 : Worked on the highlighting
0.15 : the visualization is now available within the moose finder. Really handy!!'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/4/2012 12:45'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.15'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/4/2012 17:39'!
version016: spec
	<version: '0.16' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.15 : the visualization is now available within the moose finder. Really handy!!
0.16 : added impliedBy and implying. Need excluding'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/4/2012 17:39'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.16'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/6/2012 10:55'!
version017: spec
	<version: '0.17' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.16 : added impliedBy and implying. Need excluding
0.17 : All tests are green now'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/6/2012 10:55'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.17'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/1/2012 16:10'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.1 : First shoot!!'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/1/2012 16:10'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.1'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/2/2012 00:28'!
version02: spec
	<version: '0.2' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.1 : First shoot!!
0.2 : Integrated with Moose'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/2/2012 00:28'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.2'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/2/2012 01:17'!
version03: spec
	<version: '0.3' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.2 : Integrated with Moose
0.3 : Better support in Moose'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/2/2012 01:17'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.3'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/2/2012 11:10'!
version04: spec
	<version: '0.4' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.3 : Better support in Moose
0.4 : Introduced FMFeature. No more plain string'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/2/2012 11:10'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.4'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/2/2012 13:05'!
version05: spec
	<version: '0.5' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.4 : Introduced FMFeature. No more plain string
0.5 : Yeah, all the tests are green. The parsing of the production seems to be okay for now.'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/2/2012 13:05'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.5'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/2/2012 13:30'!
version06: spec
	<version: '0.6' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.5 : Yeah, all the tests are green. The parsing of the production seems to be okay for now.
0.6 : Added visitor on constraints'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/2/2012 13:30'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.6'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/2/2012 14:47'!
version07: spec
	<version: '0.7' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.6 : Added visitor on constraints
0.7 : 
  - Fixed bugs with feature -> Feature Model
  - Make more Moose compliant'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/2/2012 14:47'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.7'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/2/2012 16:43'!
version08: spec
	<version: '0.8' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.7 : 
  - Fixed bugs with feature -> Feature Model
  - Make more Moose compliant
0.8 : 
  - added CollectingVisitor>>elementsOfKind: , very convenient
  - added new tests for the hierarchy
  - added assigment group, useful for the visualization
  - added FMProgram>>featureNamed: . Quite useful in the test'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/2/2012 16:43'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.8'. ].
! !

!ConfigurationOfFamiliar methodsFor: 'versions' stamp: 'AlexandreBergel 7/2/2012 18:15'!
version09: spec
	<version: '0.9' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.8 : 
  - added CollectingVisitor>>elementsOfKind: , very convenient
  - added new tests for the hierarchy
  - added assigment group, useful for the visualization
  - added FMProgram>>featureNamed: . Quite useful in the test
0.9 : added kind for each feature (e.g., isOptional, isOr)'.
		spec author: 'AlexandreBergel'.
		spec timestamp: '7/2/2012 18:15'.
		spec package: 'Familiar' with: 'Familiar-AlexandreBergel.9'. ].
! !
